/*
 * 
 * Przykad relacji wiele-do-wielu
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace AssociationManyToManyExample
{
    public class Location : XPObject
    {
        /*
        private int oid;
        [Key(true)]
        public int Oid
        {
            get { return oid; }
            set { oid = value; }
        }
        */
        public Location() { }
        public Location(Session Session) : base(Session) { }
        public string Name;
        public Location(string Name) { this.Name = Name; }
        [Association("LocationsDepartments", typeof(Department))]
        public XPCollection Departments { get { return GetCollection("Departments"); } }
    }

    public class Department : XPObject
    {
        /*
        private int oid;
        [Key(true)]
        public int Oid
        {
            get { return oid; }
            set { oid = value; }
        }
        */
        public Department() { }
        public Department(Session Session) : base(Session) { }
        public string Name;
        public Department(string Name) { this.Name = Name; }
        [Association("LocationsDepartments", typeof(Location))]
        public XPCollection Locations { get { return GetCollection("Locations"); } }
    }

    class Program
    {
        static void Main(string[] args)
        {
            XpoDefault.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            XpoDefault.Session.ClearDatabase();
            Location l1 = new Location("Wrocaw");
            Location l2 = new Location("Warszawa");
            Location l3 = new Location("Krakw");

            Department d1 = new Department("IT");
            Department d2 = new Department("HR");

            d1.Locations.Add(l1);
            d1.Locations.Add(l2);
            d1.Save();

            d2.Locations.Add(l1);
            d2.Locations.Add(l3);
            d2.Save();

            foreach (Department d in (new XPCollection<Department>()))
            {
                Console.WriteLine(d.Name+":");
                foreach (Location l in d.Locations)
                {
                    Console.WriteLine("    "+l.Name);
                }
            }
            l1.Delete();

            Console.ReadLine();
        }
    }
}

