using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace AssociationOneToManyExample2
{
    class Tree : XPObject
    {
        private string name;
        private Tree parent;

        public Tree() { }
        public Tree(Session Session) : base(Session) { }
        public Tree(Session Session, string Name) : base(Session) { this.Name = Name; }
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        [Association("Parent-Children")]
        public Tree Parent
        {
            get { return parent; }
            set { parent = value; }
        }

        [Association("Parent-Children")]
        public XPCollection<Tree> Children
        {
            get { return GetCollection<Tree>("Children"); }
        }

        public static void Print(Tree t, int offset)
        {
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Session s = new Session();
            s.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            s.ClearDatabase();

            Tree root = new Tree(s, "Korzen");
            Tree t1 = new Tree(s, "A");
            Tree t2 = new Tree(s, "B");
            Tree t11 = new Tree(s, "C");
            Tree t12 = new Tree(s, "D");
            Tree t21 = new Tree(s, "E");
            Tree t22 = new Tree(s, "F");

            root.Children.Add(t1);
            root.Children.Add(t2);
            t1.Children.Add(t11);
            t1.Children.Add(t12);
            t2.Children.Add(t21);
            t2.Children.Add(t22);
            t22.Children.Add(root); // tutaj robimy cykl (i dziaa!)
            root.Save();

            /*
            t21.Parent = t2;
            t22.Parent = t2;
            t12.Parent = t1;
            t11.Parent = t1;
            t1.Parent = root;
            t2.Parent = root;

            t22.Save();
            t21.Save();
            t12.Save();
            t11.Save();
            */ 
        }
    }
}

