/*
 * 
 * Pobieranie, zapisywanie i usuwanie grafu obiektw
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace AssociationOneToManyExample3
{
    class Dzial : XPObject
    {
        /*
        private int oid;
        [Key(true)]
        public int Oid
        {
            get { return oid; }
            set { oid = value; }
        }
        */

        public string Nazwa;
        public int Budzet;
        [Association("Dzial-Pracownik")]//, Aggregated]
        public XPCollection<Pracownik> Pracownik { get { return GetCollection<Pracownik>("Pracownik"); } }

        public Dzial() { }
        public Dzial(Session session) : base(session) { }
        public Dzial(string Nazwa, int Budzet)
        { this.Nazwa = Nazwa; this.Budzet = Budzet; }
    }

    class Pracownik : XPObject
    {
        /*
        private int oid;
        [Key(true)]
        public int Oid
        {
            get { return oid; }
            set { oid = value; }
        }
        */
        public string Imie;
        public string Nazwisko;
        public int Pensja;
        [Association("Dzial-Pracownik")]//, Aggregated]
        public Dzial DzialID;

        public Pracownik() { }
        public Pracownik(Session session) : base(session) { }
        public Pracownik(string Imie, string Nazwisko, int Pensja)
        { this.Imie = Imie; this.Nazwisko = Nazwisko; this.Pensja = Pensja; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            XpoDefault.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            XpoDefault.Session.ClearDatabase();

            Dzial d1 = new Dzial("HR", 10000);
            Dzial d2 = new Dzial("IT", 30000);
            Dzial d3 = new Dzial("Empty", 2000);

            Pracownik p1 = new Pracownik("Jan01", "Kowalski01", 2400);
            Pracownik p2 = new Pracownik("Jan02", "Kowalski02", 3400);
            Pracownik p3 = new Pracownik("Jan03", "Kowalski03", 2800);
            Pracownik p8 = new Pracownik("Jan04", "Kowalski04", 1800);
            d1.Pracownik.Add(p1);
            d1.Pracownik.Add(p2);
            d1.Pracownik.Add(p3);
            d1.Pracownik.Add(p8);

            Pracownik p4 = new Pracownik("Zosia01", "Nowak01", 1300);
            Pracownik p5 = new Pracownik("Zosia02", "Nowak02", 1500);
            d2.Pracownik.Add(p4);
            d2.Pracownik.Add(p5);

            d1.Save();
            d2.Save();
            d3.Save();

            /* Patrzymy na stan bazy danych po wykonaniu poniszego --- raz z Aggregated a raz bez Aggregated */
            p1.Imie = "Jan01XXX";
            d1.Save();

            /* 1. Zapisanie (raz z Aggregated w [Association("Dzial-Pracownik")] w obiekcie Dzial, a raz bez) */
            
            Console.WriteLine("Momencik...");
            Console.ReadLine();
            // W Management Console zmieniamy p3.Imie na Jan03YYY i p2.Imie na Jan02YYY 
            p2.Imie = "Jan02XXX";
            d1.Save();
            

            /* 2. Usunicie dziau (raz z Aggregated w [Association("Dzial-Pracownik")] w obiekcie Dzial, a raz bez) */
            /* Robimy te rzne wersje dziedziczenia */
            
            d1.Delete();
            //p1.Delete();
            

            /* 3. Usunicie pracownika (raz z Aggregated w [Association("Dzial-Pracownik")] w obiekcie Pracownik, a raz bez) */
            /* Robimy te rzne wersje dziedziczenia */
            
            p2.Delete();

            // Przywrocenie ,,do ycia'' obiektu zamarkowanego do usunicia
            p2.SetMemberValue("GCRecord", null);
         
            XpoDefault.Session.PurgeDeletedObjects();
        }
    }
}

