/*
 * 
 * Program sprawdzajcy szybko dziaania aplikacji w nastpujcych scenariuszy:
 * (a) Tworzony jest DataLayer (wraz z Assemblies) i sesje s tworzone na podstawie tego DataLayer
 * (b) Tworzony jest DataLayer (bez Assemblies) i sesje s tworzone na podstawie tego DataLayer
 * (c) Sesja tworzona jest za kadym razem na podstawie ConnectionString
 * (d) Sesja tworzona jest za kadym razem na podstawie obiektu Connection
 * Wyniki testw: (a) < (b) < (d) < (c)
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Reflection;
using System.Configuration;

using DevExpress.Xpo;
using DevExpress.Xpo.DB;
using DevExpress.Xpo.Metadata;

namespace DataLayerExample
{
    class Osoba : XPObject
    {
        public Osoba() { }
        public Osoba(Session Session) : base(Session) { }

        private string imie;

        public string Imie
        {
            get { return imie; }
            set { imie = value; }
        }
        private string nazwisko;

        public string Nazwisko
        {
            get { return nazwisko; }
            set { nazwisko = value; }
        }
        private string telefon;

        public string Telefon
        {
            get { return telefon; }
            set { telefon = value; }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            //string ConnectionString = "Data Source=.; Initial Catalog=Test; Integrated Security=true";
            //string ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            string ConnectionString = MSSqlConnectionProvider.GetConnectionString(".", "Test");

            XPDictionary dictionaryXPO = new ReflectionDictionary();
            dictionaryXPO.GetDataStoreSchema( typeof(Osoba).Assembly );
            IDataStore storeXPO = XpoDefault.GetConnectionProvider(ConnectionString, AutoCreateOption.DatabaseAndSchema);
            //IDataLayer layerXPO = new SimpleDataLayer(storeXPO);
            IDataLayer layerXPO = new ThreadSafeDataLayer(dictionaryXPO, storeXPO);
            

            SqlConnection connection = new SqlConnection(ConfigurationManager.AppSettings["ConnectionString"]);

            Console.ReadLine();
            Console.WriteLine("START");

            for (int i = 0; i < 400; i++)
            {
                // Pierwszy sposb tworzenia sesji
                Session s = new Session(layerXPO);
                //s.CreateObjectTypeRecords();

                // Drugi sposb tworzenia sesji
                //Session s = new Session();
                //s.ConnectionString = ConnectionString;
                //s.Connection = connection;
                
                Osoba o = new Osoba(s);
                o.Imie = "Jan" + i;
                o.Nazwisko = "Kowalski" + i;
                o.Telefon = i.ToString();
                o.Save();
            }

            Console.WriteLine("STOP");
            Console.ReadLine();

        }
    }
}
