/*
 * 
 * Przykad rozwizuje problem: mamy abstrakcyjn klas A i dziedziczc z niej B : A.
 * Chcemy, eby w bazie dla B bya jedna tabela, ktra zawiera atrybuty z A i z B
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;
using DevExpress.Xpo.DB;

namespace InheritanceExample2
{
    [NonPersistent]
    abstract class CustomBase : XPObject
    {
        private DateTime modifyDate;
        public DateTime ModifyDate
        {
            get { return modifyDate; }
            set { modifyDate = value; }
        }

        private string modifyUser;
        public string ModifyUser
        {
            get { return modifyUser; }
            set { modifyUser = value; }
        }

        public CustomBase() { }
        public CustomBase(Session s) : base(s) { }
    }

    class Osoba : CustomBase
    {
        private string imie;
        public string Imie
        {
            get { return imie; }
            set { imie = value; }
        }

        private string nazwisko;
        public string Nazwisko
        {
            get { return nazwisko; }
            set { nazwisko = value; }
        }

        public Osoba() { }
        public Osoba(Session s) : base(s) { }
    }

    class Jednostka : CustomBase
    {
        private string nazwa;
        public string Nazwa
        {
            get { return nazwa; }
            set { nazwa = value; }
        }

        public Jednostka() { }
        public Jednostka(Session s) : base(s) { }
    }

    class Program
    {
        static void Main(string[] args)
        {
            string connectionString = ConfigurationManager.AppSettings["ConnectionString"];
            XpoDefault.DataLayer = XpoDefault.GetDataLayer(connectionString, AutoCreateOption.DatabaseAndSchema);
            XpoDefault.Session.ClearDatabase();

            Session s = new Session();
            s.ConnectionString = connectionString;
            Osoba o = new Osoba(s);
            o.Imie = "Jan";
            o.Nazwisko = "Kowalski";
            o.ModifyDate = new DateTime(2007, 10, 10);
            o.ModifyUser = "Administrator";
            o.Save();

            Jednostka j = new Jednostka(s);
            j.Nazwa = "Warszawa";
            j.Save();

            Osoba o2 = new Osoba(s);
            o2.Imie = "Ewa";
            o2.Nazwisko = "Nowak";
            o2.ModifyDate = new DateTime(2006, 12, 12);
            o2.ModifyUser = "Dyrektor";
            o2.Save();
        }
    }
}