/*
 * 
 * W przypadku relacji Dzial(1)-Pracownik(wiele), w momencie pobrania pracownika, automatycznie docigany jest
 * odpowiedni dzial. Pytanie, czy te wywoania wyzwalaj si acuchowo.
 * 
 * Robimy ledzenie w SQLProfiler dwa razy: z aggregated i bez aggregated
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

using DevExpress.Xpo;
using DevExpress.Xpo.DB;
using System.Configuration;

namespace LazyLoading
{
    public class A : XPObject
    {
        public A() { }
        public A(Session session) : base(session) { }
        public string Name;
        [Association("AB"), Aggregated]
        public XPCollection<B> B { get { return GetCollection<B>("B"); } }
    }
    public class B : XPObject
    {
        public B() { }
        public B(Session session) : base(session) { }
        public string Name;

        private XPDelayedProperty a = new XPDelayedProperty();
        [Delayed( "a" )]
        [Association( "AB" ), Aggregated]
        public A ID_A
        {
            get { return (A)a.Value; }
            set { a.Value = (A)value; }
        }

        //[Association( "AB" )]//, Aggregated]
        //public A ID_A;

        [Association( "BC" )]//, Aggregated]
        public XPCollection<C> C { get { return GetCollection<C>("C"); } }
    }
    public class C : XPObject
    {
        public C() { }
        public C(Session session) : base(session) { }
        public string Name;
        [Association( "BC" )]//, Aggregated]
        public B ID_B;
        [Association("CD")]
        public XPCollection<D> D { get { return GetCollection<D>("D"); } }
    }
    public class D : XPObject
    {
        public D() { }
        public D(Session session) : base(session) { }
        public string Name;

        //private XPDelayedProperty c = new XPDelayedProperty();
        //[Delayed("c")]
        //[Association("CD"), Aggregated]
        //public C ID_C
        //{
        //    get { return (C)c.Value; }
        //    set { c.Value = (C)value; }
        //}

        [Association( "CD" )]
        public C ID_C;
    }

    class Program
    {
        static void Main(string[] args)
        {

            Session session = new Session();
            session.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            session.ClearDatabase();

            A a = new A(session);
            B b = new B(session);
            C c = new C(session);
            D d = new D(session);
            a.Name = "Jestem A";
            b.Name = "Jestem B";
            c.Name = "Jestem C";
            d.Name = "Jestem D";
            a.B.Add(b);
            b.C.Add(c);
            c.D.Add(d);

            a.Save();

            a.Name = "Jestem sobie A";
            b.Name = "Jestem sobie B";
            c.Name = "Jestem sobie C";
            d.Name = "Jestem sobie D";

            a.Save();

            Session session2 = new Session();
            session2.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

            D dd = session2.GetObjectByKey<D>(1);

            Console.WriteLine(dd.Oid);

            Console.ReadLine();

        }
    }
}

