/*
 * 
 * Przykad rnych sposobw utrwalania obiektw
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace PersistenceExample
{
    [Persistent]
    class Person1
    {
        private int id;
        private string firstName;
        private string lastName;
        private string email;

        [Key(true)]
        public int Id
        {
            get { return id; }
            set { id = value; }
        }
        [Size(30)]
        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }
        [Size(50)]
        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
        [NonPersistent]
        public string Email
        {
            get { return email; }
            set { email = value; }
        }
    }

    class Person2 : XPBaseObject
    {
        public Person2() { }
        public Person2(Session Session) : base(Session) { }
        [Key(true)]
        public int Id;
        public string FirstName;
        public string LastName;
        public string Email;
    }

    class Person3 : XPCustomObject
    {
        public Person3() { }
        public Person3(Session Session) : base(Session) { }

        private int id;
        private string firstName;
        private string lastName;
        private string email;

        [Key(true)]
        public int Id
        {
            get { return id; }
            set { id = value; }
        }
        [Size(30)]
        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }
        [Size(50)]
        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
        [Size(100)]
        public string Email
        {
            get { return email; }
            set { email = value; }
        }
    }

    class Person4 : XPObject
    {
        public Person4() { }
        public Person4(Session Session) : base(Session) { }

        private string firstName;
        private string lastName;
        private string email;

        [Size(30)]
        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }
        [Size(50)]
        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
        [Size(100)]
        public string Email
        {
            get { return email; }
            set { email = value; }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Session session = new Session();
            session.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
            session.ClearDatabase();

            Person1 p1 = new Person1();
            p1.FirstName = "Joe";
            p1.LastName = "Black";
            p1.Email = "joe.black@death.com";
            session.Save(p1);

            Person2 p2 = new Person2(session);
            p2.FirstName = "Joe";
            p2.LastName = "Black";
            p2.Email = "joe.black@death.com";
            p2.Save();

            Person3 p3 = new Person3(session);
            p3.FirstName = "Joe";
            p3.LastName = "Black";
            p3.Email = "joe.black@death.com";
            p3.Save();

            Person4 p4 = new Person4(session);
            p4.FirstName = "Joe";
            p4.LastName = "Black";
            p4.Email = "joe.black@death.com";
            p4.Save();

            p4.LastName = "Czarny";
            p4.Save();

            session.Delete(p1);
            p2.Delete();
            p3.Delete();
            p4.Delete();
        }
    }
}
