using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

using DevExpress.Xpo;

namespace TransactionsExample
{
    class Person : XPObject
    {
        public Person() { }
        public Person(Session Session) : base(Session) { }

        private string firstName;
        private string lastName;
        private string email;

        [Size(30)]
        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }
        [Size(50)]
        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
        [Size(100)]
        public string Email
        {
            get { return email; }
            set { email = value; }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            using (Session session = new Session())
            {
                session.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
                session.ClearDatabase();
                session.BeginTransaction();
                Person p = new Person(session);
                p.FirstName = "Joe";
                p.LastName = "Black";
                p.Save();
                if (p.FirstName == "Joe") session.CommitTransaction();
                else session.RollbackTransaction();
            }
        }
    }
}
